#!/usr/bin/env python
# -*- coding: utf-8 -*-

# License : public domain
# gw: added shebang, new parameter "roundness", fixed for GMIC versions > 3.x(?)
#     added missing translations

# =============START OF CODE TO BE COPIED
from gimpfu import *


def gmic(*args):
    if 'plug_in_gmic_qt' in dir(pdb):
        return pdb.plug_in_gmic_qt(args[0], args[1], args[2], args[3], '-fx_' + args[4])
    #            pdb.plug_in_gmic_qt(image, drawable, input, output, command)
    else:
        return pdb.plug_in_gmic(args[0], args[1], args[2], '-gimp_' + args[4])


def boxEffectMask(img, layer, custom_mask, blur, grain, grooveSmooth):
    gimp.context_push()
    img.undo_group_start()

    # work with layers:
    layers = img.layers

    layer = layers[-1]
    # print("******** layer: ", pdb.gimp_item_get_name(layer))
    position = pdb.gimp_image_get_item_position(img, layer)

    layerCopy = pdb.gimp_layer_copy(layer, False)
    pdb.gimp_image_add_layer(img, layerCopy, position)

    # kaleidoscope
    pdb.gimp_image_set_active_layer(img, layer)
    gmic(img, layer, 1, 0, 'kaleidoscope 50,50,0,0,100,10,2')
    pdb.plug_in_gauss(img, layer, blur, blur, 1)

    # bord
    layerBord = custom_mask

    pdb.gimp_image_set_active_layer(img, layerBord)

    bordChannel = pdb.gimp_channel_new_from_component(img, 0, 'bordChannel')
    pdb.gimp_image_insert_channel(img, bordChannel, None, 0)
    mask = pdb.gimp_layer_create_mask(layerCopy, 6)
    pdb.gimp_layer_add_mask(layerCopy, mask)
    pdb.gimp_invert(mask)

    # groove
    pdb.plug_in_edge(img, layerBord, 2, 3, 0)

    pdb.gimp_image_set_active_layer(img, layerBord)
    gmic(img, layerBord, 1, 0, 'smooth_antialias 100,10,5')  # smooth_antialias 100,10,5,0,50,50

    pdb.plug_in_gauss(img, layerBord, grooveSmooth, grooveSmooth, 1)
    pdb.plug_in_emboss(img, layerBord, 315, 45, 6, True)
    pdb.gimp_curves_spline(layerBord, 0, 6, [0, 0, 180, 128, 255, 255])
    pdb.gimp_layer_set_mode(layerBord, LAYER_MODE_GRAIN_MERGE)

    # noise
    pdb.gimp_image_merge_down(img, layerCopy, 0)
    res = pdb.gimp_image_merge_down(img, layerBord, 0)

    pdb.gimp_image_set_active_layer(img, res)
    gmic(img, res, 1, 0, 'noise ' + str(int(grain)) + ',0,0,1')  # 0,0,1,0,50,50

    img.undo_group_end()
    gimp.context_pop()


register(
    "python-fu-boxeffectMask",  # name
    "Metall Schachtel eigene Maske",  #
    "Metall Schachtel eigene Maske. . .",  # help
    "gimplyworxs",  # author
    "gimplyworxs",  # copyright
    "2025-03-14",  # date
    "Metall Schachtel eigene Maske" + '...',  # menu name
    "RGB,RGBA",
    [
        (PF_IMAGE, "image", "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_LAYER, "custom_mask", "Maskenebene", None),
        (PF_SLIDER, "blur", "Weichzeichenradius", 25, (0, 50, 1)),
        (PF_SLIDER, "grain", "Körnigkeit", 12, (0, 50, 1)),
        (PF_SLIDER, "grooveSmooth", "Rille glätten", 10, (0, 25, 1)),
    ],
    [],
    boxEffectMask,
    menu="<Image>/Filters/Artistic",
)

main()
